tic;
global jumpstate;
global q_gas;
global q_el;
global penalty;
global CI;
global var_cost;
global possible_states;
global values;
global state_vector;
global q_gas_total;
global q_el_total;
% global q_gas_sum;
% global q_el_sum;
global numvalues;

% readDynProgData;
InitializeProfileDynamicprog;

p_el = [70 70];
p_gas = [1000 1000];
p_carbon = [0 0];
%q_gas_sum=zeros(numvalues(1),numvalues(2),length(possible_states),length(possible_states));
%q_el_sum=zeros(numvalues(1),numvalues(2),length(possible_states),length(possible_states));
% values_sum=zeros(numvalues(1),numvalues(2),length(possible_states),length(possible_states));

numvalues =[90 90 50];
production_matrix_gas_1 = zeros(numvalues(1), numvalues(2), numvalues(3), length(possible_states),length(possible_states));
production_matrix_gas_2 = zeros(numvalues(1), numvalues(2), numvalues(3), length(possible_states),length(possible_states));
production_matrix_el_1 = zeros(numvalues(1), numvalues(2), numvalues(3), length(possible_states),length(possible_states));
production_matrix_el_2 = zeros(numvalues(1), numvalues(2), numvalues(3), length(possible_states),length(possible_states));
profits = zeros(23,23,2);

%Loops j, k and l varies the relationships between the different prices. 
%k varies the value of p_el(1) relative to the production cost related to
%p_gas(1) and p_carbon(1).
%l varies p_el(2) relative to production cost in the same way as k.
%m varies the value of p_gas(2) relative to p_gas(1).

for k = 1:numvalues(1)
    for l = 1:numvalues(2)
        for m = 1:numvalues(3)
            
            %Historical (2005-2012) extreme values for:
            %(p_el - var_cost)/(p_gas + CI*p_carbon): 1.50 - 8.50
            %(p_gas(2)-CI*p_carbon(2))/(p_gas(1)-CI*p_carbon(1)): 0.55 - 3
            
            p_gas(2)= (m*3/50 + 1/2) * ( p_gas(1) + CI * p_carbon(1) ) - CI * p_carbon(2);
            p_el(1) = (k*4.5/100 + 1/2) * (p_gas(1) + p_carbon(1) * CI ) + var_cost;
            p_el(2) = (l*4.5/100 + 1/2) * (p_gas(2) + p_carbon(2) * CI ) + var_cost;
            
            
            % Loading a 23[states]*23[states]*2[distinct prices] matrix of profits
            % before and after midnight
            profits(:,:,1) = ( p_el(1) - var_cost ) * q_el(:,:) - (p_gas(1) + p_carbon(1)*CI ) * q_gas(:,:) + (jumpstate(:,:)-1)*penalty;
            profits(:,:,2) = ( p_el(2) - var_cost ) * q_el(:,:) - (p_gas(2) + p_carbon(1)*CI ) * q_gas(:,:) + (jumpstate(:,:)-1)*penalty;


            %Loading matrix of values and setting penalty on non-startstates.
            %Startstate initial value is zero
            %Matrix 'values' indicate the value at the START of period 't', i.e. index
            %t=25 indicates the value at the END of the last period.
            values(:,:,25,:) = -penalty;
            %Here, endstate = 1,2,3,4,5, but refer to the elements of the vector
            %'possible_states'.

            for endstate= 1 : length(possible_states)
                values(:,possible_states(endstate),25,endstate) = 0;
                values(:,:,25,endstate) = values(:,:,25,endstate)+ (jumpstate(:,:)-1)*penalty;
                for t = 24:-1:1
                    values(:,:,t,endstate) = repmat(max(transpose(values(:,:,t+1,endstate)),[],1),23,1) + profits(:,:,floor((t-1)/12+1));
                end
            end

            q_gas_total = zeros(2,length(possible_states),length(possible_states));
            q_el_total = zeros(2,length(possible_states),length(possible_states));

            for endstate = 1:length(possible_states)
                for startstate = 1:length(possible_states)
                    state_vector(1,startstate,endstate) = possible_states(startstate);
                    for t=2:25
                        [temp state_vector(t,startstate,endstate)] = max(values(state_vector(t-1,startstate,endstate),:,t,endstate));
                        q_gas_total(floor((t-2)/12+1),startstate,endstate) = q_gas_total(floor((t-2)/12+1),startstate,endstate) + q_gas(state_vector(t-1,startstate,endstate),state_vector(t,startstate,endstate));
                        q_el_total(floor((t-2)/12+1),startstate,endstate) = q_el_total(floor((t-2)/12+1),startstate,endstate) + q_el(state_vector(t-1,startstate,endstate),state_vector(t,startstate,endstate));
                    end
                end
            end
            
            %This loop is used to construct the matrix of production rates
            %given k,l,m.
            for startstate = 1:length(possible_states)
                for endstate = 1:length(possible_states)
                    for i = 1:2
                        %production_matrix_gas/el_i(k,l,m,startstate,endstate):
                        %i = 1 for day 1, 2 for day 2.
                        production_matrix_gas_1(k,l,m,startstate,endstate) = q_gas_total(1,startstate,endstate);
                        production_matrix_gas_2(k,l,m,startstate,endstate) = q_gas_total(2,startstate,endstate);
                        production_matrix_el_1(k,l,m,startstate,endstate) = q_el_total(1,startstate,endstate);
                        production_matrix_el_2(k,l,m,startstate,endstate) = q_el_total(2,startstate,endstate);
                    end
                end
            end

            %This loop is basically used to create graphs.
%             if m == 30
%                 for startstate = 1:length(possible_states)
%                     for endstate = 1:length(possible_states)
%                         q_gas_sum(k,l,startstate,endstate) = sum(q_gas_total(:,startstate,endstate));
%                         q_el_sum(k,l,startstate,endstate) = sum(q_el_total(:,startstate,endstate));
%                         values_sum(k,l,startstate,endstate) = max(values(startstate,:,1,endstate));
%                     end
%                 end
%             end
            
        end
    end
    disp(k);
end

production_matrix_gas_1 = reshape(production_matrix_gas_1,numvalues(1)*numvalues(2)*numvalues(3)*length(possible_states)*length(possible_states),1);
production_matrix_gas_2 = reshape(production_matrix_gas_2,numvalues(1)*numvalues(2)*numvalues(3)*length(possible_states)*length(possible_states),1);
production_matrix_el_1 = reshape(production_matrix_el_1,numvalues(1)*numvalues(2)*numvalues(3)*length(possible_states)*length(possible_states),1);
production_matrix_el_2 = reshape(production_matrix_el_2,numvalues(1)*numvalues(2)*numvalues(3)*length(possible_states)*length(possible_states),1);

dlmwrite('production_matrix_gas_1_36.txt',production_matrix_gas_1);
dlmwrite('production_matrix_gas_2_36.txt',production_matrix_gas_2);
dlmwrite('production_matrix_el_1_36.txt',production_matrix_el_1);
dlmwrite('production_matrix_el_2_36.txt',production_matrix_el_2);

time = toc;
disp(time);